package kcg.faics.susa.service.impl;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.List;

import kcg.faics.cmmn.bbs.BaseFileService;
import kcg.faics.susa.vo.SusaFileVO;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.web.WebAppConfiguration;

/**
 * SusaFileServiceImpl 테스트 클래스.
 * 
 * @author kimnomin
 *
 */
@RunWith(SpringJUnit4ClassRunner.class)
@WebAppConfiguration
@ContextConfiguration(locations = { "classpath:/spring/context-*.xml" })
public class SusaFileServiceImplTest {

	/**
	 * 외사수사 파일 관련 서비스 객체.
	 */
	@Autowired
	private BaseFileService<SusaFileVO> susaFileService;
	
	/**
	 * insert 메서드 테스트.
	 * 
	 * @throws Exception 기본 예외 처리
	 */
	@Test
	public void insertFileTest() throws Exception {
		SusaFileVO susaFileVO = new SusaFileVO();
		
		susaFileVO.setParentSeq(1);
		susaFileVO.setOrders(1);
		susaFileVO.setOrgName("실제파일명.png");
		susaFileVO.setSaveName("저장파일명.png");
		
		int result = susaFileService.insert(susaFileVO);
		
		assertEquals(1,  result);
	}
	
	/**
	 * delete 메서드 테스트.
	 * 
	 * CASE 1. 전체 목록을 가져와 첫 번째 레코드를 대상으로 지정한 후, 해당 레코드를 삭제하면 결과가 성공이 나와야 한다.
	 * CASE 2. 삭제된 레코드를 다시 SELECT하면 NULL이어야 한다.
	 * 
	 * @throws Exception 기본 예외 처리
	 */
	@Test
	public void deleteTest() throws Exception {
		List<SusaFileVO> tmpList = susaFileService.selectList(null);
		SusaFileVO deleteTargetVO = tmpList.get(0);
		
		int result = susaFileService.delete(deleteTargetVO);
		assertEquals(1,  result);		
		
		SusaFileVO resultTargetVO = susaFileService.select(deleteTargetVO);
		assertTrue((resultTargetVO == null));
	}
}
